package com.community.huiju.model;

import com.baomidou.mybatisplus.annotation.TableName;
import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 工单处理表
 * </p>
 *
 * @author jobob
 * @since 2019-02-14
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("tp_ticket_record")
public class TpTicketRecord implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 小区id
     */
    private Integer communityId;

    /**
     * 工单id
     */
    private Integer ticketId;

    /**
     * 自动生成的提示信息
     */
    private String content;

    /**
     * 流转状态      0:待分配  1:拒绝受理 2:待处理 3:正在处理 4:待评价 5:已评价 6:已终止
     */
    private String status;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 创建时间
     */
    private LocalDateTime createDate;


}
