package com.community.huiju.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.community.commom.mode.ResponseBean;
import com.community.commom.session.UserElement;
import com.community.huiju.dao.BillMapper;
import com.community.huiju.dao.BillStatementMapper;
import com.community.huiju.model.BillInvoice;
import com.community.huiju.dao.BillInvoiceMapper;
import com.community.huiju.service.IBillInvoiceService;
import com.google.common.collect.Maps;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 * 缴费单 服务实现类
 * </p>
 *
 * @author weiximei
 * @since 2019-02-13
 */
@Service
public class BillInvoiceServiceImpl extends ServiceImpl<BillInvoiceMapper, BillInvoice> implements IBillInvoiceService {

    /** 缴费项表 **/
    @Autowired
    private BillMapper billMapper;

    /** 缴费单 **/
    @Autowired
    private BillInvoiceMapper billInvoiceMapper;

    /** 账单流水表 **/
    @Autowired
    private BillStatementMapper billStatementMapper;

    @Override
    public ResponseBean getBillList(String parameter, UserElement userElement) {
        ResponseBean responseBean = new ResponseBean();
        JSONObject jsonObject = JSONObject.parseObject(parameter);

        Integer pageNum = jsonObject.getInteger("pageNum");
        Integer pageSize = jsonObject.getInteger("pageSize");
        // 缴费项ID
        Integer billId = jsonObject.getInteger("billId");
        // 期
        String phase = jsonObject.getString("phase");
        // 栋
        String building = jsonObject.getString("building");
        // 单元
        String unit = jsonObject.getString("unit");
        // 户号
        String roomNo = jsonObject.getString("roomNo");
        // 业主姓名
        String ownerName = jsonObject.getString("ownerName");
        // 缴费状态
        Integer billStatus = jsonObject.getInteger("billStatus");
        // 缴费人姓名
        String payName = jsonObject.getString("payName");

        Map<String, Object> map = Maps.newHashMap();
        map.put("billId", billId);
        map.put("phase", phase);
        map.put("building", building);
        map.put("unit", unit);
        map.put("roomNo", roomNo);
        map.put("ownerName", ownerName);
        map.put("billStatus", billStatus);
        map.put("payName", payName);
        map.put("communityId", userElement.getCommunityId());


        Page<BillInvoice> page = new Page<>();
        page.setCurrent(pageNum);
        page.setSize(pageSize);
        IPage<BillInvoice> invoiceIPage = billInvoiceMapper.selectBillInvoice(page, map);

        Map<String, Object> respMap = Maps.newHashMap();
        respMap.put("pageNum", invoiceIPage.getCurrent());
        respMap.put("pageSize", invoiceIPage.getSize());
        respMap.put("total", invoiceIPage.getTotal());
        respMap.put("list", invoiceIPage.getRecords());

        responseBean.addSuccess(respMap);

        return responseBean;
    }
}
