package com.community.huiju.service.impl;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.community.commom.mode.ResponseBean;
import com.community.huiju.dao.TpTicketMapper;
import com.community.huiju.dao.UserMapper;
import com.community.huiju.model.TpBuildingOwnerInfo;
import com.community.huiju.model.TpTicket;
import com.community.huiju.model.User;
import com.community.huiju.service.TpTicketService;
import com.community.huiju.vo.TpTicketVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 工单表 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-02-14
 */
@Service
public class TpTicketServiceImpl extends ServiceImpl<TpTicketMapper, TpTicket> implements TpTicketService {

    @Autowired
    private  TpTicketMapper tpTicketMapper;

    @Autowired
    private UserMapper userMapper;
    @Override
    public ResponseBean ticketLiset(String parameter) {
         ResponseBean response= new ResponseBean<>();
        TpTicket   ticket= JSONObject.parseObject(parameter, TpTicket.class);

        JSONObject object= JSONObject.parseObject(parameter);
        Integer pageNum = object.getInteger("pageNum");
        Integer pageSize = object.getInteger("pageSize");

        Page<TpTicket> page = new Page<>();
        page.setSize(pageSize == null ? 10 : pageSize);
        page.setCurrent(pageNum == null ? 1 : pageNum);
        IPage<TpTicket> pageInfo = tpTicketMapper.ticketList(page,ticket);
        List<TpTicket> ticketList = pageInfo.getRecords();

        List<TpTicket> tpTicketArrayList= new ArrayList<>();

        for (TpTicket tpTicket:ticketList){
            TpTicketVO tpTicketVO= new TpTicketVO();
            BeanUtils.copyProperties(tpTicket, tpTicketVO);
            /*查询当前受理人*/
            String userName=userMapper.selectByIdUserName(tpTicket.getTpUserId());
            tpTicketVO.setTpUserNmae(userName);

            /*查询当前工单创建人*/
            String createUserNmae=userMapper.selectByIdUserName(tpTicket.getCreateUser());
            tpTicketVO.setCreateUserNmae(createUserNmae);
            tpTicketArrayList.add(tpTicketVO);
        }
        HashMap map=new HashMap<>();
        map.put("list",tpTicketArrayList);
        map.put("total", pageInfo.getTotal());
        map.put("pageNum", pageInfo.getCurrent());
        map.put("pageSize", pageInfo.getSize());
        response.addSuccess(map);
        return response;
    }
}
